/*
 * MosP - Mind Open Source Project    http://www.mosp.jp/
 * Copyright (C) MIND Co., Ltd.       http://www.e-mind.co.jp/
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */
package jp.mosp.common.action;

import java.util.Date;

import jp.mosp.common.MosPAction;
import jp.mosp.common.common.BaseVo;
import jp.mosp.common.common.MospConst;
import jp.mosp.common.common.MospException;
import jp.mosp.common.common.MospUtility;
import jp.mosp.common.dao.MosPUserDao;
import jp.mosp.common.dto.CmUserDto;
import jp.mosp.common.utils.VariousUtil;
import jp.mosp.common.vo.MosPPasswordVo;

/**
 * @author yoshida
 *
 */
public class MosPPasswordAction extends MosPAction {
	
	// コマンド
	private static final String	CMD_PASSWORD_SHOW			= "C1050";
	private static final String	CMD_PASSWORD_CHANGE			= "C1051";
	/**
	 * 強制変更
	 */
	public static final String	CMD_PASSWORD_FORCE_CHANGE	= "C1052";
	

	/**
	 * アクション
	 */
	public void action() throws Exception {
		// VOの取得及び設定
		prepareVo(false);
		// 初期処理
		init();
		// コマンド毎の処理
		if (cmd.equals(CMD_PASSWORD_SHOW)) {
			// 表示
			show();
		} else if (cmd.equals(CMD_PASSWORD_CHANGE)) {
			// 更新
			update();
		} else if (cmd.equals(CMD_PASSWORD_FORCE_CHANGE)) {
			// 強制変更
			forceChange();
		} else {
			throw new MospException(MospConst.EX_CMD_INVALID);
		}
	}
	
	@Override
	protected BaseVo getSpecificVo() {
		return new MosPPasswordVo();
	}
	
	@Override
	protected void init() throws Exception {
		MosPPasswordVo vo = (MosPPasswordVo)getVo();
		// メニューコマンド設定
		vo.setAryMenu(vo.CMD_MENU_INPUT);
		if (hasSystemAuth()) {
			vo.setAryMenu(vo.CMD_MENU_SYSTEM2);
		}
		// メニューへボタンの非表示設定
		vo.setMode(MosPPasswordVo.MODE_FORCE_UPDATE);
	}
	
	@Override
	protected void show() throws Exception {
		MosPPasswordVo vo = (MosPPasswordVo)getVo();
		vo.setUserId(user.getUserId());
		vo.setUserName(user.getUserName());
		// メニューへボタンの表示
		vo.setMode(MosPPasswordVo.MODE_SHOW);
	}
	
	/**
	 * 強制変更
	 * @throws Exception 	例外処理が発生した場合
	 */
	private void forceChange() throws Exception {
		MosPPasswordVo vo = (MosPPasswordVo)getVo();
		// 表示
		show();
		// メニューへボタンの非表示設定
		vo.setMode(MosPPasswordVo.MODE_FORCE_UPDATE);
	}
	
	@Override
	protected void update() throws Exception {
		MosPPasswordVo vo = (MosPPasswordVo)getVo();
		vo.setParams(request);
		// DAOの準備
		MosPUserDao dao = part().mospuser().getMosPUserDao();
		// DTOの準備
		CmUserDto dto = dao.findForUpdate(vo.getUserId());
		// 存在確認
		chkExist(dto);
		// パラメータの妥当性確認
		vo.validate(dto.getPassword());
		// 値の設定
		dto.setPassword(MospUtility.encrypt(vo.getHdnNewPassword(), hasMospSeJar()));
		// パスワード変更日時をセットする。
		dto.setChangePass(new Date());
		// データの更新
		dao.update(dto, false);
		// コミット
		commit();
		// メッセージ設定
		vo.setMessage(getMessage(MospConst.MSG_UPDATE, ""));
		// メニューへボタンの表示
		vo.setMode(MosPPasswordVo.MODE_SHOW);
		if (VariousUtil.isDefaultPassWord(user.getUserId(), vo.getHdnNewPassword())) {
			// メニューへボタンの非表示設定
			vo.setMode(MosPPasswordVo.MODE_FORCE_UPDATE);
		}
	}
	
}
